#!/usr/bin/awk -f

BEGIN {
	DEBUG = 0;
	ret = 1;
	infile = "/etc/network/interfaces";
	
	chan2freq[1] = "2.412";
	chan2freq[2] = "2.417";
	chan2freq[3] = "2.422";
	chan2freq[4] = "2.427";
	chan2freq[5] = "2.432";
	chan2freq[6] = "2.437";
	chan2freq[7] = "2.442";
	chan2freq[8] = "2.447";
	chan2freq[9] = "2.452";
	chan2freq[10] = "2.457";
	chan2freq[11] = "2.462";
	chan2freq[12] = "2.467";
	chan2freq[13] = "2.472";
	chan2freq[14] = "2.484";

	# read config
	while(0 < getline<infile) {
		if (/^iface /) {
			iface = "";
			if (/^iface +[^ ]/) {
				iface = $2;
			}
		}
		else if ("" != iface) {
			if (/^[\t ]*wireless_mode /) {
				mode[iface] = tolower($2);
			}
			if (/^[\t ]*wireless_essid /) {
				essid[iface] = "\""$2"\"";
			}
			else if (/^[\t ]*wireless_channel /) {
				channel[iface] = $2;
			}
		}
	}

	# read actual interfaces
	while(getline<"/proc/net/wireless") {
		if (/^$/) break;
		# exclude wifi interfaces
		if (sub(":", "") && !($1~/wifi/) ) {
			iface = $1;
			
			# read current status
			while("iwconfig "iface" 2>/dev/null"|getline) {
				if (/^$/) break;
				if (sub("Mode:", "")) mode=tolower($1);
				if (sub("Frequency:", "")) freq=$2;
				if (sub("ESSID:", "")) essid=$4;
			}
			
			# dont reconfigure if essid don't match
			if (essid != essid[iface]) {
				system("logger 'not reconfiguring "iface": ESSIDs dont match (" essid " - " essid[iface]")'");
				break;
			}
			
			# re-configure if necessary
			conf_freq = chan2freq[channel[iface]]"GHz";
			if (mode != mode[iface] || conf_freq != freq ) {
				cmd="iwconfig "iface" mode "mode[iface]" essid "essid[iface]" channel "channel[iface];
				system(cmd);
				system("logger 'had to reset "iface": "freq", "mode"'");
				ret=0;
			}
		}
	}
	
	if (ERRNO) {
		#print infile": "ERRNO > "/dev/stderr";
		exit 2;
	}
	exit ret;
}
